from __future__ import absolute_import
from pymbolic.interop.sympy import SympyToPymbolicMapper, PymbolicToSympyMapper

import pymbolic.primitives as prim
import sympy as sp


class MyPymbolicToSympyMapper(PymbolicToSympyMapper):
    def map_subscript(self, expr):
        indices = expr.index if isinstance(expr.index, tuple) else (expr.index,)
        return sp.Symbol("{}${}".format(expr.aggregate, "$".join(str(i) for i in indices)))


class MySympyToPymbolicMapper(SympyToPymbolicMapper):
    def map_Symbol(self, expr):
        s = expr.name.split('$')
        r = prim.Variable(s[0])
        if len(s) == 1:
            return r
        if len(s) == 2:
            return prim.Subscript(r, prim.Variable(s[1]))
        else:
            return prim.Subscript(r, tuple(prim.Variable(i) for i in s[1:]))


def simplify_pymbolic_expression(e):
    sympyexpr = MyPymbolicToSympyMapper()(e)
    simplified = sp.simplify(sympyexpr)
    return MySympyToPymbolicMapper()(simplified)
